; #########################################################################
; File:       EditBox11.asm
; #########################################################################

comment * @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


          @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ *

    include EditBox11.inc

; ##############################################################################################
.data
;-------------------------------------------
align 4
_MenuName       db "Menu1", 0                   ; definido em rsrc.rc
;...............................................
align 4
_ClassName      db "WndClass", 0
align 4
_DisplayName    db "EditBox11", 0
align 4
_hWnd           dd 0
_hInstance      dd 0
_hdc            dd 0
;**********************************************************
;                   StatusBar             
_hStatus        dd 0
align 4                
_StatClass      db  'msctls_statusbar32',0
align 4                
_StaBarError    dd 0
align 4
_sbParts        dd 4 dup (0)
; #########################################################
align 4
_rcleft1        dd 100h         
_rctop1         dd 044h         
_rcright1       dd 200h         
_rcbottom1      dd 0A2h         

align 4
                dd 30
                dd 0
_StrText        db 30 dup (20h)
_StrNula        db 0   

                db 33
_InfoTxt1       db 'Type something.                  '
_InfoTxt2       db 'The caret doesnt move correctly  '
_InfoTxt3       db 'Restart: press ESC               '
_InfoTxt4       db 'Use Backspace, -> or <-          '

                dd 11
                dd 11
_Titulo         db 'Hello World', 0
;....................................................
;               Fontes
_FontTerminal   db "Terminal",0     
_FontMSSSerif   db "MS Sans Serif",0
_FontMSSerif    db "MS Serif",0
_FontSystem     db "System",0
_FontModern     db "Modern",0
_FontFixSys     db "FixedSys",0
_FontCourier    db "Courier",0
_FontTimes      db 'times new roman', 0
_FontVerdana    db 'Verdana', 0                
_FontArialBlack db 'Arial Black', 0                
_FontImpact     db 'Impact', 0                

                dd LF_FACESIZE
                dd 0
_FaceName       db LF_FACESIZE dup (?)
                db 0

_TitFont        db 'Fonte:'
;....................................................
align 4
                db 255
_ErrorString    db 256 dup (0)
; ##############################################################################################
.data?
_ScreenDimX     dd ?
_ScreenDimY     dd ?
;......................
_ClientLeftX    dd ?
_ClientTopY     dd ?
_ClientRightX   dd ?
_ClientBottomY  dd ?

                
_WidthStr       dd ?
                dd ?

_hDC            dd ?
;_ps     PAINTSTRUCT <?>

pStatus         dd ?
hTxtFont        dd ?
;.................................
_pBuffer        dd ? 
;---------------------------------
_LChar          dd ?
_AChar          dd ?

_hFont          dd ?
_hOFont         dd ?

_tm             TEXTMETRIC  <?>         ; text metrics
_lf             LOGFONT <?>

_hFont1         dd ?
_hFont2         dd ?
_hFont3         dd ?
_hFont4         dd ?
_hFont5         dd ?
_hFont6         dd ?
_hFont7         dd ?
_hFont8         dd ?
_hFont9         dd ?
_hFont10        dd ?
_hFont11        dd ?
_hFont12        dd ?
_hFont13        dd ?
_hFont14        dd ?
_hFont15        dd ?
_hFont16        dd ?

_hOFont1        dd ?
; 
; LF_FACESIZE      equ 32
; LF_FULLFACESIZE  equ 64
;_lpelfe         ENUMLOGFONTEX <?>
;_lpntme         NEWTEXTMETRICEX <?>

; #########################################################################
.code
; -----------------------------------------------------------------------
align 16
start:          invoke GetModuleHandle, NULL 
                mov    _hInstance, eax

                call    InitCommonControls

                invoke   WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
                invoke   ExitProcess, eax       
; #########################################################################
;                               procedures
; ########################################################################
align 16
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
        LOCAL   wc :WNDCLASSEX
        LOCAL   msg:MSG

        mov   wc.cbSize,         sizeof WNDCLASSEX
        mov   wc.style,          CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW or CS_OWNDC
        mov   wc.lpfnWndProc,    offset WndProc      
        mov   wc.cbClsExtra,     NULL
        mov   wc.cbWndExtra,     NULL
        push  hInst
	  pop   wc.hInstance
        mov   wc.hIcon, NULL
        mov   wc.hIconSm, NULL 
        invoke  CreateSolidBrush, 00000000h 
        mov   wc.hbrBackground, eax                      
        mov   wc.lpszMenuName, offset _MenuName      ; menu name in resource file
        mov   wc.lpszClassName, offset _ClassName    ; window class name        
        invoke LoadCursor, NULL, IDC_ARROW           ; system cursor
        mov   wc.hCursor, eax

        invoke RegisterClassEx, ADDR wc              ; register the window class

        invoke  GetSystemMetrics, SM_CXSCREEN
        mov     _ScreenDimX, eax
        invoke  GetSystemMetrics, SM_CYSCREEN
        mov     _ScreenDimY, eax
        invoke  OrigemWindow, 800, 572

        invoke CreateWindowEx, WS_EX_OVERLAPPEDWINDOW,
                              ADDR _ClassName,
                              ADDR _DisplayName,
                              WS_OVERLAPPEDMIN,             
                              0, 0, edx, eax,
                              NULL, NULL, hInst, NULL
        mov     _hWnd, eax  

        invoke ShowWindow, _hWnd, SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow, _hWnd                   ; update the display

          ; ************
          ; Message Loop
          ; ************
@@:       invoke GetMessage, ADDR msg, NULL, 0, 0         ; get each message
          cmp    eax, 0                                   ; exit if GetMessage()
          je     @F                                       
          ;
          invoke TranslateMessage, ADDR msg               ; translate it
          invoke DispatchMessage,  ADDR msg               ; send it to message proc
          jmp    @B
          ;
@@:       mov    eax, 0         
          ret
WinMain   endp
; ########################################################################
align 16
WndProc         proc    hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD
                
                SWITCH  iMsg
                CASE    WM_CREATE

                    invoke  GetDC, hWnd
                    mov     _hdc, eax           ; main window hDC ( is CS_OWNDC )

                    CREATESTATUS

;.......................... Font Face Name .........................

                    invoke    GetDC, _hStatus
                    mov       _hDC, eax
                    mov       ebx, offset _FaceName
                    
                    invoke    GetTextFace, _hDC, [ebx - 8], ebx
                    ;
                    xor       ecx, ecx
@@:                 inc       ecx
                    cmp       byte ptr [ebx + ecx - 1], 0
                    jne       @B
                    ;
                    dec       ecx
                    mov       dword ptr [ebx - 4], ecx                    
                    invoke    ReleaseDC, _hStatus, _hDC                    

;........................ Init input String .......................

                    mov       ebx, offset _StrText
                    mov       dword ptr [ebx - 4], 0 
                    mov       _pBuffer, 0  

;........................ Cria Fontes ..............................
                    
                    invoke  CreateFonte, addr _FontCourier, 8, offset _hFont1
                    invoke  CreateFonte, addr _FontCourier, 12, offset _hFont2
                    invoke  CreateFonte, addr _FontCourier, 16, offset _hFont3
                    invoke  CreateFonte, addr _FontCourier, 26, offset _hFont4 

                    invoke  CreateFonte, addr _FontTimes, 14, offset _hFont5
                    invoke  CreateFonte, addr _FontTimes, 18, offset _hFont6
                    invoke  CreateFonte, addr _FontTimes, 22, offset _hFont7
                    invoke  CreateFonte, addr _FontTimes, 26, offset _hFont8

                    invoke  CreateFonte, addr _FontVerdana, 12, offset _hFont9
                    invoke  CreateFonte, addr _FontVerdana, 16, offset _hFont10
                    invoke  CreateFonte, addr _FontArialBlack, 12, offset _hFont11
                    invoke  CreateFonte, addr _FontArialBlack, 16, offset _hFont12

                    invoke  CreateFonte, addr _FontImpact, 12, offset _hFont13
                    invoke  CreateFonte, addr _FontImpact, 16, offset _hFont14
                    invoke  CreateFonte, addr _FontMSSSerif, 12, offset _hFont15
                    invoke  CreateFonte, addr _FontMSSSerif, 16, offset _hFont16

;.......................................................
                CASE    WM_SETFOCUS
                
                    invoke     CreateCaret, _hStatus, NULL, 1, 15
                    invoke     SetCaretPos, 2, 3 
                    invoke     ShowCaret, _hStatus                    

                CASE    WM_SIZE

                    invoke  GetClientRect, hWnd, addr _ClientLeftX

                CASE    WM_PAINT
                    
                    invoke   DrawEdge, _hdc, addr _rcleft1, 5h, 400Fh 
                    ;
                    ; Info Text
                    ; 
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Torrado     
                    invoke  TextOutA, _hdc, 50, 24, offset _InfoTxt1, 33
                    invoke  TextOutA, _hdc, 50, 38, offset _InfoTxt2, 33
                    invoke  TextOutA, _hdc, 50, 52, offset _InfoTxt3, 33
                    invoke  TextOutA, _hdc, 50, 66, offset _InfoTxt4, 33 
                    ;---------------------------------------------------
                    invoke  SetBkColor, _hdc, Amarelo
                    invoke  SetTextColor, _hdc, Azul 
                    invoke  TextOutA, _hdc, 350, 78, addr _TitFont, 5

                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Verdeclaro                     
                    mov     edx, offset _FaceName    
                    invoke  TextOutA, _hdc, 348, 110, edx, [edx - 4]  
                    ;---------------------------------------------------
                    ;invoke  GetDC, _hStatus                    
                    ;invoke  SetBkMode, _hDC, TRANSPARENT                        
                    ;invoke  SetTextColor, _hDC, 0h      
                    ;invoke  TextOut, _hDC, 2, 3, offset _Titulo, 8
                    ;invoke  ReleaseDC, _hStatus, _hDC 
                    
                    ;---------------------------------------------------
                    SELECTFONT _hFont1
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Rosa                  
                    invoke  TextOutA, _hdc, 540, 24, offset _InfoTxt1, 33
                    REMOVEFONT

                    SELECTFONT _hFont2
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Azeitona                    
                    invoke  TextOutA, _hdc, 540, 38, offset _InfoTxt2, 33
                    REMOVEFONT

                    SELECTFONT _hFont3
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, 00FF00D0h            
                    invoke  TextOutA, _hdc, 540, 52, offset _InfoTxt3, 33
                    REMOVEFONT

                    SELECTFONT _hFont4
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, 00FF0ADDh            
                    invoke  TextOutA, _hdc, 540, 66, offset _InfoTxt4, 33
                    REMOVEFONT  
                    
                    ;---------------------------------------------------
                    SELECTFONT _hFont5
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Azeitona            
                    invoke  TextOutA, _hdc, 20, 200, offset _InfoTxt1, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont6
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Rosa            
                    invoke  TextOutA, _hdc, 20, 214, offset _InfoTxt2, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont7
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Torrado
                    invoke  TextOutA, _hdc, 20, 238, offset _InfoTxt3, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont8
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Amareloclaro            
                    invoke  TextOutA, _hdc, 20, 262, offset _InfoTxt4, 33
                    REMOVEFONT                  
                    ;---------------------------------------------------
                    SELECTFONT _hFont9
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Azeitona            
                    invoke  TextOutA, _hdc, 420, 200, offset _InfoTxt1, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont10
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Rosa            
                    invoke  TextOutA, _hdc, 420, 214, offset _InfoTxt2, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont11
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Torrado
                    invoke  TextOutA, _hdc, 420, 238, offset _InfoTxt3, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont12
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Azulclaro            
                    invoke  TextOutA, _hdc, 420, 262, offset _InfoTxt4, 33
                    REMOVEFONT 
                    ;---------------------------------------------------
                    SELECTFONT _hFont13
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Azeitona            
                    invoke  TextOutA, _hdc, 20, 400, offset _InfoTxt1, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont14
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Rosa            
                    invoke  TextOutA, _hdc, 20, 414, offset _InfoTxt2, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont15
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, Torrado
                    invoke  TextOutA, _hdc, 20, 438, offset _InfoTxt3, 33
                    REMOVEFONT                  

                    SELECTFONT _hFont16
                    invoke  SetBkColor, _hdc, 0h
                    invoke  SetTextColor, _hdc, AzulBebe        ;Amareloclaro            
                    invoke  TextOutA, _hdc, 20, 462, offset _InfoTxt4, 33
                    REMOVEFONT                                  
                                                     
;                 
                CASE    WM_CHAR

                        mov     ebx, offset _StrText

                        mov     eax, wParam
                        cmp     eax, VK_RETURN
                        je     _dWndProc

                        cmp     eax, VK_TAB
                        je     _dWndProc
                        
                        cmp     eax, VK_ESCAPE
                        jne     _VK_BACK
                        
                        mov     _pBuffer, 0
                        mov     dword ptr [ebx - 4], 0
                        ;
                        invoke  SendMessage, _hStatus, SB_SETTEXT, 0, addr _StrNula
                        invoke  SetCaretPos, 2, 3
                        jmp     _dWndProc 

_VK_BACK:               cmp     eax, VK_BACK
                        jne     _VK_CHAR
                        ;
                        cmp     _pBuffer, 0
                        je      _r   
                        ;  
                        mov     edx, _pBuffer
                        mov     ecx, dword ptr [ebx - 4]
                        cmp     ecx, _pBuffer
                        je      _i

                        push    ecx
                        sub     ecx, _pBuffer
@@:                     movzx   eax, byte ptr [ebx + edx]
                        mov     byte ptr [ebx + edx - 1], al
                        inc     edx
                        dec     ecx
                        jnz     @B
                        pop     ecx
                        
                        mov     edx, _pBuffer                        
                        
_i:                     dec     ecx
                        mov     dword ptr [ebx - 4], ecx
                        dec     edx
                        mov     _pBuffer, edx
                        jmp     _print

_VK_CHAR:               mov     ecx, _pBuffer
                        cmp     ecx, dword ptr [ebx - 8]
                        jne     @F
                        ;
                        dec     ecx

@@:                     mov     byte ptr [ebx + ecx], al
                        inc     ecx
                        mov     _pBuffer, ecx
                        
                        cmp     ecx, dword ptr [ebx - 4]
                        jbe     short _print

                        mov     dword ptr [ebx - 4], ecx

_print:                 invoke  SendMessage, _hStatus, SB_SETTEXT, 0, addr _StrNula

_PosCaret:              invoke  GetWindowDC, _hStatus
                        mov     _hDC, eax
                        
                        invoke  SetBkMode, _hDC, TRANSPARENT                        
                        invoke  SetTextColor, _hDC, 0h      
                        invoke  TextOut, _hDC, 2, 3, ebx, [ebx - 4] 

                        ; 
                        ; Caret position
                        ; 
                        invoke  GetTextExtentPoint32, _hDC, ebx, _pBuffer, addr _WidthStr
                        mov     eax, _WidthStr

                        add     eax, 2
                        invoke  SetCaretPos, eax, 3                        
                        invoke  ReleaseDC, _hStatus, _hDC
;                                         
                CASE    WM_KEYDOWN
                
                        mov     ebx, offset _StrText 
                        mov     ecx, dword ptr [ebx - 4]
                        mov     edx, _pBuffer
                                       
                        mov     eax, wParam                        
                        cmp     eax, VK_LEFT          
                        jne     _VK_RIGHT

                        cmp     edx, 0
                        jne     @F

_r:                     invoke  MessageBeep, MB_OK
                        jmp     _dWndProc
                        ;
@@:                     dec     edx
                        mov     _pBuffer, edx
                        jmp     _PosCaret
                        
_VK_RIGHT:              cmp     eax, VK_RIGHT
                        jne     _dWndProc
                        ;
                        cmp     edx, ecx
                        je      _r
                         
                        inc     edx
                        mov     _pBuffer, edx
                        jmp     _PosCaret
;                 
                CASE    WM_COMMAND
                     switch wParam  
                     case IDM_End
                        invoke   SendMessage, hWnd, WM_CLOSE, 0, 0
                     endsw
; 
                CASE    WM_DESTROY
                     ;
                     ; Perform cleanup tasks here
                     ; **************************
                     
                     invoke  PostQuitMessage, NULL
                     xor     eax, eax
                     ret
; 
                ENDSW

_dWndProc:      invoke  DefWindowProc, hWnd, iMsg, wParam, lParam
                ret
WndProc         endp
; #############################################################################
align 16
OrigemWindow    proc    Larg:DWORD, Alt:DWORD
                ;
                ; Largura = dimenso do screen
                ; ----------------------------
                mov     edx, _ScreenDimX
                cmp     edx, Larg
                jbe     @F
                ;
                mov     edx, Larg
                ;
@@:             mov     eax, Alt                
                cmp     eax, _ScreenDimY
                jbe     @F
                ;
                mov     eax, _ScreenDimY
                ;
@@:             ret
OrigemWindow    endp
; 
align 16
DisplayError    proc
                push    eax
                push    ecx
                push    edx
                ;
                invoke  GetLastError
                test    eax, eax
                jz      @F                
                ;
                invoke  FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, 0, eax, 0, 
                                        offset _ErrorString, 255, 0
                ;                                        
                invoke  MessageBox, 0, offset _ErrorString, 0, 0
                ;
@@:             pop     edx
                pop     ecx
                pop     eax
                ret
DisplayError    endp
; 
align 16
CriaFonte        proc   pFonte:DWORD, Alt:DWORD
                 ;
                 invoke  GetWindowDC, _hStatus
                 mov     _hDC, eax                 
                 ;
                 ;mov     ebx, Alt
                 ;
                 ;invoke  CreateFont, ebx,edx,0,0,400,0,0,0, OEM_CHARSET,OUT_DEFAULT_PRECIS,\
                 ;invoke  CreateFont, ebx,0,0,0,400,0,0,0, OEM_CHARSET,OUT_DEFAULT_PRECIS,\                                  
                 invoke  CreateFont, Alt,0,0,0,700,0,0,0, 
                                     DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
                                     CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
                                     FF_DONTCARE or FF_MODERN, pFonte

                 mov     _hFont, eax
                 cmp     eax, NULL
                 jne     @F
                 ;
                 ; Erro ao criar a fonte
                 ; ---------------------
                 call     DisplayError

                 invoke  ReleaseDC, _hStatus, _hDC                 
                 stc
                 ret
                 ;
                 ; eax = objecto a substituir no DC 
                 ; --------------------------------
@@:              invoke  SelectObject, _hDC, eax
                 mov     _hOFont, eax
                 ;
                 ;
                 ;
                 invoke  GetTextMetrics, _hDC, addr _tm 
                 ;
                 ; Save the average character width and height. 
                 ; -------------------------------------------
                 mov     eax, _tm.tmAveCharWidth
                 mov     _LChar, eax                    ; largura dos caracteres
                 mov     eax, _tm.tmHeight
                 mov     _AChar, eax  
                 ;
_eCriaFonte:     invoke  ReleaseDC, _hStatus, _hDC
                 clc
                 ret
CriaFonte        endp
; 
;   estrutura LOGFONT usada por CreateFontIndirect
;   --------------------------- ******************
CreateFonte     proc pName:DWORD, Alt:DWORD, pHand:DWORD

                mov     eax, Alt
                mov     _lf.lfHeight, eax       
                mov     _lf.lfWidth, 0
                mov     _lf.lfEscapement, 0
                mov     _lf.lfOrientation, 0
                ;mov     _lf.lfWeight, FW_NORMAL  ; FW_BOLD
                mov     _lf.lfWeight, FW_BOLD                
                mov     _lf.lfItalic, FALSE
                mov     _lf.lfUnderline, FALSE
                mov     _lf.lfStrikeOut, FALSE
                mov     _lf.lfCharSet, ANSI_CHARSET or OEM_CHARSET or DEFAULT_CHARSET
                mov     _lf.lfOutPrecision, OUT_DEFAULT_PRECIS or OUT_DEVICE_PRECIS
                mov     _lf.lfClipPrecision, CLIP_DEFAULT_PRECIS
                mov     _lf.lfQuality, DEFAULT_QUALITY
                mov     _lf.lfPitchAndFamily, DEFAULT_PITCH 
                ;mov     _lf.lfPitchAndFamily, FIXED_PITCH or FF_MODERN or FF_DONTCARE or FF_ROMAN or FF_SWISS or DEFAULT_PITCH        
                ;mov     _lf.lfFaceName[LF_FACESIZE]         

                mov     edx, pName
                mov     ebx, offset _lf
                ;
@@:             movzx   eax, byte ptr [edx]                
                mov     byte ptr [ebx].LOGFONT.lfFaceName, al
                ;
                inc     edx
                inc     ebx
                ;
                or      eax, eax
                jnz     @B

                invoke  CreateFontIndirect, addr _lf

                mov     edx, pHand
                mov     dword ptr [edx], eax
                cmp     eax, 0
                jne     @F
                
                call     DisplayError
                stc
                ret
                
@@:             clc
                ret
CreateFonte     endp
; 
end start
